Index: /trunk/gli/src/org/greenstone/gatherer/cdm/LanguageManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/LanguageManager.java	(revision 4931)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/LanguageManager.java	(revision 4932)
@@ -6,13 +6,7 @@
  * University of Waikato, New Zealand.
  *
- * <BR><BR>
- *
  * Author: John Thompson, Greenstone Digital Library, University of Waikato
  *
- * <BR><BR>
- *
  * Copyright (C) 1999 New Zealand Digital Library Project
- *
- * <BR><BR>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -21,12 +15,8 @@
  * (at your option) any later version.
  *
- * <BR><BR>
- *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
- *
- * <BR><BR>
  *
  * You should have received a copy of the GNU General Public License
@@ -35,53 +25,24 @@
  *########################################################################
  */
-
- 
-
-
-
-
 package org.greenstone.gatherer.cdm;
 /**************************************************************************************
- * Title:        Gatherer
- * Description:  The Gatherer: a tool for gathering and enriching a digital collection.
- * Copyright:    Copyright (c) 2001
- * Company:      The University of Waikato
  * Written:      08/05/02
  * Revised:      17/11/02 - Commented
+ *               07/07/03 - DOM support
  **************************************************************************************/
-import java.awt.BorderLayout;
-import java.awt.Color;
-import java.awt.Component;
-import java.awt.Dimension;
-import java.awt.GridLayout;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.KeyEvent;
-import java.io.BufferedReader;
-import java.io.File;
-import java.io.FileReader;
-import java.util.ArrayList;
-import java.util.Collections;
-import java.util.Enumeration;
-import java.util.Iterator;
-import java.util.LinkedHashMap;
-import java.util.StringTokenizer;
-import java.util.Vector;
-import javax.swing.BorderFactory;
-import javax.swing.DefaultListCellRenderer;
-import javax.swing.DefaultListModel;
-import javax.swing.ListModel;
-import javax.swing.JButton;
-import javax.swing.JComboBox;
-import javax.swing.JLabel;
-import javax.swing.JList;
-import javax.swing.JPanel;
-import javax.swing.JScrollPane;
-import javax.swing.JTextArea;
-import javax.swing.JTextField;
-import javax.swing.event.ListSelectionEvent;
-import javax.swing.event.ListSelectionListener;
+import java.awt.*;
+import java.awt.event.*;
+import java.io.*;
+import java.util.*;
+import javax.swing.*;
+import javax.swing.event.*;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.Control;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
 import org.greenstone.gatherer.cdm.Language;
+import org.greenstone.gatherer.cdm.LanguageListCellRenderer;
+import org.w3c.dom.*;
 /** This class manages the language commands, remembering both a list of languages to build indexes in, plus the default language.
  * @author John Thompson, Greenstone Digital Library, University of Waikato
@@ -89,291 +50,31 @@
  */
 public class LanguageManager
-    extends DefaultListModel {
-    /** A reference to the collection design manager. */
-    private CollectionDesignManager manager = null;
+    extends DOMProxyListModel {
+
+    static final private Dimension LABEL_SIZE = new Dimension(125,25);
+
     /** The visual controls for this manager. */
     private Control controls = null;
-    /** A reference to the Gatherer. */
-    private Gatherer gatherer = null;
     /** A reference to this class as a model, for the inner controls class. */
-    private ListModel model = null;
+    private DOMProxyListModel model = null;
     /** A hashtable of code->name mappings of known languages. */
     private LinkedHashMap known_languages = null;
     /** The default language object. */
     private Language default_language = null;
-
-    static final private Dimension LABEL_SIZE = new Dimension(125,25);
-    /** Constructor.
-     * @param gatherer A reference to the <strong>Gatherer</strong>.
-     * @param manager A reference to the <strong>CollectionDesignManager</strong>.
-     */
-    public LanguageManager(Gatherer gatherer, CollectionDesignManager manager) {
-	super();
-	this.gatherer = gatherer;
-	this.known_languages = new LinkedHashMap();
-	this.manager = manager;
+ 
+   /** Constructor. */
+    public LanguageManager(Element languages_element) {
+	super(languages_element, CollectionConfiguration.LANGUAGE_ELEMENT, new Language());
+	
+	Gatherer.println("LanguageManager: " + getSize() + " languages parsed.");
+
 	this.model = this;
-	loadLanguages();
-    }
-    /** Method to add a new language.
-	  * @param language The <strong>Language</strong> to add.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void addLanguage(Language language) {
-	if(!contains(language)) {
-				// Add alphabetically.
-	    for(int index = 0; index < size(); index++) {
-		Language sibling = (Language) get(index);
-		int position = language.compareTo(sibling);
-		// Sibling is before language.
-		if(position > 0) {
-		    // Carry on.
-		}
-		// Language is equal to, or before sibling. Insert it.
-		else if(position == 0 || position < 0) {
-		    add(index, language);
-		    gatherer.c_man.configurationChanged();
-		    return;
-		}
-	    }
-				// If we got this far, we haven't inserted language, and we are out of model so.
-	    addElement(language);
-	    gatherer.c_man.configurationChanged();
-	}
-    }
-    /** Method to retrieve the control for this manager.
-	  * @return A <strong>JPanel</strong> containing the controls.
-	  */
-    public JPanel getControls() {
-	if(controls == null) {
-	    controls = new Control();
-	}
-	return controls;
-    }
-    /** Method to retrieve the default language code.
-	  * @return A <strong>Language</strong> containing a two letter code.
-	  */
-    public Language getDefaultLanguage() {
-	// If no default is set...
-	if(default_language == null) {
-				// And we have other assigned languages, use the first one of them.
-	    if(size() >= 1) {
-		default_language = (Language) get(0);
-	    }
-				// And we have nothing else, use English.
-	    else {
-		default_language = getLanguage("en", false);
-		// Remember to add it.
-		addLanguage(default_language);
-	    }
-	}
-	return default_language;
-    }
-    /** Method to retrieve a certain language object by its code.
-     * @param code The two letter code of a language, as a <strong>String</strong>.
-     * @param assigned_only If <i>true</i> only those languages currently having indexes built for them are checked, otherwise the known languages buffer is checked.
-     * @return The <strong>Language</strong> that matches the given code, or <i>null</i> if no such language exists.
-     */
-    public Language getLanguage(String code, boolean assigned_only) {
-	if(assigned_only) {
-	    for(int i = 0; i < size(); i++) {
-		Language pos = (Language)get(i);
-		///ystem.err.println("Comparing " + pos.getCode() + " and " + code);
-		if(pos.getCode().equals(code)) {
-		    return pos;
-		}
-	    }
-	}
-	else {
-	    if(known_languages.containsKey(code)) {
-		return new Language((Language)known_languages.get(code));
-	    }
-	}
-	return null;
-    }
-    /** Method to return a list of the known language codes.
-     * @return An <strong>ArrayList</strong> containing a series of alphabetically sorted two letter codes.
-     */
-    public ArrayList getLanguageCodes() {
-	ArrayList result = new ArrayList();
-	Iterator key_iter = known_languages.keySet().iterator();
-	while(key_iter.hasNext()) {
-	    result.add(known_languages.get(key_iter.next()));
-	}
-	//for(Enumeration keys = known_languages.keys(); keys.hasMoreElements(); ) {
-	//	result.add(known_languages.get(keys.nextElement()));
-	//}
-	//Collections.sort(result);
-	return result;
-    }
-    /** Mark the current set of controls, if any, as obsolete and deallocate them. If further need of the controls will cause new controls to be created.
-	* @see org.greenstone.gatherer.cdm.IndexManager.Control
-	*/
-    public void invalidateControls() {
-	if(controls != null) {
-	    controls.destroy();
-	}
-	controls = null;
-    }
-
-    /** Determine if the given language is the current default language.
-	  * @param language The <strong>Language</strong> to test.
-	  * @return <i>true</i> if the language is the default one, <i>false</i> otherwise.
-	  */
-    public boolean isDefaultLanguage(Language language) {
-	return (language.equals(default_language));
-    }
-    /** This method attempts to parse a language command from the given string. If such a command is parsed, it is immediately added to the list of languages.
-	  * @param command The <strong>String</strong> containing a possible language command.
-	  * @return A <i>boolean</i> which is <i>true</i> if a command was parsed, <i>false</i> otherwise.
-	  * @see org.greenstone.gatherer.cdm.Language
-	  */
-    public boolean parse(String command) {
-	String command_lc = command.toLowerCase();
-	if(command_lc.startsWith("languages")) {
-	    StringTokenizer tokenizer = new StringTokenizer(command);
-	    tokenizer.nextToken();
-	    while(tokenizer.hasMoreTokens()) {
-		String code = tokenizer.nextToken();
-		if(known_languages.containsKey(code)) {
-		    Language language = (Language)known_languages.get(code);
-		    addElement(new Language(language));
-		}
-		else {
-		    addElement(new Language(code, code, false));
-		}
-	    }
-	    return true;
-	}
-	if(command_lc.startsWith("defaultlanguage")) {
-	    StringTokenizer tokenizer = new StringTokenizer(command);
-	    tokenizer.nextToken();
-	    if(tokenizer.hasMoreTokens()) {
-		String code = tokenizer.nextToken();
-		Language language = getLanguage(code, true);
-		if(language == null) {
-		    language = new Language(code, (String)known_languages.get(code), true);
-		    addElement(language);
-		}
-		else {
-		    language.setDefault(true);
-		}
-		setDefault(language);
-	    }
-	    return true;
-	}
-	return false;
-    }
-    /** Method to cause the list appearance to update if the selection changes. */
-    public void refreshAppearance() {
-	fireContentsChanged(this, 0, size());
-    }
-    /** Method to remove a certain language.
-	  * @param language The <strong>Language</strong> to remove.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void removeLanguage(Language language) {
-	removeElement(language);
-	if(default_language != null && default_language.equals(language)) {
-	    default_language = null;
-	}
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to set the default language.
-	  * @param language The <strong>Language</strong> to use as a default, or <i>null</i> for no default.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.collection.CollectionManager
-	  */
-    public void setDefault(Language language) {
-	// Unset existing.
-	Language old = null;
-	if(default_language != null) {
-	    old = default_language;
-	    default_language.setDefault(false);
-	    default_language = null;
-	}
-	// Now set the new if its not null.
-	if(language != null) {
-	    default_language = language;
-	    default_language.setDefault(true);
-	}
-	// Now cause the model to refresh any lists that are listening.
-	int start = 0;
-	int end = size() - 1;
-	if(default_language != null && old != null) {
-	    int index_default = indexOf(default_language);
-	    int index_old = indexOf(old);
-	    if(index_default < index_old) {
-		start = index_default;
-		end = index_old;
-	    }
-	    else {
-		start = index_old;
-		end = index_default;
-	    }
-	}
-	else if(default_language != null) {
-	    start = end = indexOf(default_language);
-	}
-	else {
-	    start = end = indexOf(old);
-	}
-	fireContentsChanged(this, 0, size());
-	gatherer.c_man.configurationChanged();
-    }
-    /** Method to translate this object into a block of commands as you you expect to find in the collection configuration file.
-     * @return A <strong>String</string> containing a series of commands.
-     */
-    public String toString() {
-	StringBuffer text = new StringBuffer();
-	if(size() > 1) {
-	    text.append("languages ");
-	    for(int i = 0; i < size(); i++) {
-		Language language = (Language) get(i);
-		text.append(language.getCode());
-		if(i < size() - 1) {
-		    text.append(" ");
-		}
-		else {
-		    text.append("\n");
-		}
-	    }
-				// Only bother with default language if there is more than one language.
-	    if(default_language != null) {
-		text.append("defaultlanguage ");
-		text.append(default_language.getCode());
-		text.append("\n");
-	    }
-	    text.append("\n");
-	}
-	return text.toString();
-    }
-    /** Overloaded to call get with both a key and an empty argument array.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  */
-    private String get(String key) {
-	return get(key, null);
-    }
-    /** Used to retrieve a property value from the Locale specific ResourceBundle, based upon the key and arguments supplied. If the key cannot be found or if some other part of the call fails a default (English) error message is returned. <BR>
-	  * Here the get recieves a second argument which is an array of Strings used to populate argument fields, denoted {<I>n</I>}, within the value String returned. Note that argument numbers greater than or equal to 32 are automatically mapped to the formatting String named Farg<I>n</I>.
-	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
-	  * @param args A <strong>String[]</strong> used to populate argument fields within the complete String.
-	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
-	  * @see org.greenstone.gatherer.Gatherer
-	  * @see org.greenstone.gatherer.Dictionary
-	  */
-    private String get(String key, String args[]) {
-	if(key.indexOf('.') == -1) {
-	    key = "CDM.LanguageManager." + key;
-	}
-	return gatherer.dictionary.get(key, args);
-    }
-    /** This method loads a series of code->language mappings into known_languages, by reading from the 'languages.dat' file, which is essentially a verbatim copy of the ISO 639 Standard.
-	 * @see org.greenstone.gatherer.cdm.Language
-	  */
-    private void loadLanguages() {
+	// Retrieve the default language
+	NodeList default_language_elements = CollectionDesignManager.collect_config.getDocumentElement().getElementsByTagName(CollectionConfiguration.LANGUAGE_DEFAULT_ELEMENT);
+	if(default_language_elements.getLength() > 0) {
+	    default_language = new Language((Element)default_language_elements.item(0));
+	}
+	// Load a series of code->language mappings into known_languages, by reading from the 'languages.dat' file, which is essentially a subset of the ISO 639 Standard.
+	known_languages = new LinkedHashMap();
 	try {
 	    File in_file = new File("languages.dat");
@@ -384,11 +85,16 @@
 		if(!entry.startsWith("#")) {
 		    StringTokenizer tokenizer = new StringTokenizer(entry);
-		    String name = tokenizer.nextToken();
-		    String code = tokenizer.nextToken().toLowerCase();
-		    Language language = new Language(code, name, false);
-		    known_languages.put(code, language);
+		    if(tokenizer.countTokens() >= 2) {
+			String name = tokenizer.nextToken();
+			String code = tokenizer.nextToken().toLowerCase();
+			known_languages.put(code, name);
+		    }
 		}
 	    }
 	    in.close();
+	    in_reader.close();
+	    in = null;
+	    in_reader = null;
+	    in_file = null;
 	}
 	catch (Exception error) {
@@ -397,23 +103,156 @@
     }
 
+    /** Method to add a new language.
+     * @param language The <strong>Language</strong> to add.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void addLanguage(Language language) {
+	if(!contains(language)) {
+	    Element element = language.getElement();
+	    // Locate where we should insert this new subcollection. 
+	    Node target_node = CollectionConfiguration.findInsertionPoint(element);
+	    // Failing that we insert immediately after a language string
+	    add(root, language, target_node);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	known_languages.clear();
+	known_languages = null;
+    }
+
+    /** Method to retrieve the control for this manager.
+     * @return the Control for editing the language partitions
+     */
+    public Control getControls() {
+	if(controls == null) {
+	    // Build controls
+	    controls = new LanguageControl();
+	}
+	return controls;
+    }
+
+    /** Method to retrieve the default language code.
+     * @return A <strong>Language</strong> containing a two letter code.
+     */
+    public Language getDefaultLanguage() {
+	// If no default is set...
+	if(default_language != null && default_language.isAssigned()) {
+	    return default_language;
+	}
+	return null;
+    }
+
+    /** Method to retrieve a certain language object by its code.
+     * @param code The two letter code of a language, as a <strong>String</strong>.
+     * @param assigned_only If <i>true</i> only those languages currently having indexes built for them are checked, otherwise the known languages buffer is checked.
+     * @return The <strong>Language</strong> that matches the given code, or <i>null</i> if no such language exists.
+     */
+    public Language getLanguage(String code) {
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    Language language = (Language) getElementAt(i);
+	    if(language.getCode().equals(code)) {
+		return language;
+	    }
+	}
+	return null;
+    }
+
+    public ArrayList getLanguages() {
+	return children();
+    }
+
+    /** Method to return a list of the known language codes.
+     * @return an ArrayList containing the series of known language codes as per the languages.dat file
+     */
+    public ArrayList getLanguageCodes() {
+	return new ArrayList(known_languages.keySet());
+    }
+
+    public String getLanguageName(String code) {
+	return (String) known_languages.get(code);
+    }
+
+    /** Method to remove a certain language.
+     * @param language The <strong>Language</strong> to remove.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void removeLanguage(Language language) {
+	remove(language);
+	if(default_language != null && default_language.equals(language)) {
+	    default_language = null;
+	}
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Method to set the default language.
+     * @param language The <strong>Language</strong> to use as a default, or <i>null</i> for no default.
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void setDefault(Language language) {
+	if(language != null) {
+	    if(default_language == null) {
+		// Create the default index element, and place immediately after indexes element.
+		Element default_language_element = root.getOwnerDocument().createElement(CollectionConfiguration.LANGUAGE_DEFAULT_ELEMENT);
+		default_language = new Language(default_language_element);
+		Node target_node = CollectionConfiguration.findInsertionPoint(default_language_element);
+		if(target_node != null) {
+		    root.getOwnerDocument().getDocumentElement().insertBefore(default_language_element, target_node);
+		}
+		else {
+		    root.getOwnerDocument().getDocumentElement().appendChild(default_language_element);
+		}
+	    }
+	    default_language.setAssigned(true);
+	    default_language.setCode(language.getCode());
+	}
+	else {
+	    if(default_language != null) {
+		default_language.setAssigned(false);
+	    }
+	}
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Overloaded to call get with both a key and an empty argument array.
+	  * @param key A <strong>String</strong> which is mapped to a initial String within the ResourceBundle.
+	  * @return A <strong>String</strong> which has been referenced by the key String and that either contains no argument fields, or has had the argument fields automatiically populated with formatting Strings of with argument String provided in the get call.
+	  */
+    private String get(String key) {
+	if(key.indexOf('.') == -1) {
+	    key = "CDM.LanguageManager." + key;
+	}
+	return Gatherer.dictionary.get(key, (String[])null);
+    }
+
     /** This class represents the visual component of the Language Manager. */
-    private class Control
-	extends JPanel {
+    private class LanguageControl
+	extends JPanel 
+	implements Control {
 	/** The button to add a new language support. */
-	private JButton add = null;
+	private JButton add_button = null;
 	/** The button to clear the current default language. */
-	private JButton clear_default = null;
+	private JButton clear_button = null;
 	/** The button to remove a supported language. */
-	private JButton remove = null;
+	private JButton remove_button = null;
 	/** The button to set the current language as the default one. */
-	private JButton set_default = null;
+	private JButton set_button = null;
 	/** A combobox listing the available supported languages. */
-	private JComboBox selector = null;
+	private JComboBox selector_combobox = null;
 	/** A list of currently supported languages. */
-	private JList list = null;
+	private JList language_list = null;
 	/** A description of the language currently selected. */
-	private JTextArea description = null;
+	private JTextArea description_textarea = null;
 	/** The text field showing the currently name of the default language. Non-editable. */
-	private JTextField default_language_value = null;
+	private JTextField default_language_field = null;
 	/** Constructor.
 	 * @see org.greenstone.gatherer.cdm.LanguageManager.Control.AddListener
@@ -425,5 +264,5 @@
 	 * @see org.greenstone.gatherer.cdm.LanguageManager.Control.TranslateListener
 	 */
-	public Control() {
+	public LanguageControl() {
 	    super();
 	    // Creation.
@@ -434,6 +273,5 @@
 	    title_label.setOpaque(true);
 
-	    list = new JList(model);
-	    list.setCellRenderer(new ListRenderer());
+	    language_list = new JList(model);
 
 	    JPanel details_panel = new JPanel();
@@ -446,11 +284,11 @@
 
 	    if(default_language == null) {
-		default_language_value = new JTextField();
+		default_language_field = new JTextField();
 	    }
 	    else {
-		default_language_value = new JTextField(default_language.toString());
-	    }
-	    default_language_value.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
-	    default_language_value.setEditable(false);
+		default_language_field = new JTextField(default_language.toString());
+	    }
+	    default_language_field.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
+	    default_language_field.setEditable(false);
 
 	    JPanel control_panel = new JPanel();
@@ -459,47 +297,42 @@
 	    selector_label.setPreferredSize(LABEL_SIZE);
 
-	    selector = new JComboBox(getLanguageCodes().toArray());
-	    selector.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
+	    selector_combobox = new JComboBox(getLanguageCodes().toArray());
+	    selector_combobox.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
+	    selector_combobox.setRenderer(new LanguageListCellRenderer());
 
 	    JPanel button_panel = new JPanel();
 
-	    add = new JButton(get("Add"));
-	    add.setMnemonic(KeyEvent.VK_A);
-	    if(selector.getSelectedItem() != null) {
-		add.setEnabled(true);
-	    }
-	    else {
-		add.setEnabled(false);
-	    }
-
-	    remove = new JButton(get("Remove"));
-	    remove.setMnemonic(KeyEvent.VK_R);
-	    remove.setEnabled(false);
-
-	    clear_default = new JButton(get("Clear_Default"));
-	    clear_default.setMnemonic(KeyEvent.VK_C);
-	    clear_default.setEnabled(false);
-
-	    set_default = new JButton(get("Set_Default"));
-	    set_default.setMnemonic(KeyEvent.VK_S);
-	    set_default.setEnabled(false);
+	    add_button = new JButton(get("Add"));
+	    add_button.setMnemonic(KeyEvent.VK_A);
+
+	    remove_button = new JButton(get("Remove"));
+	    remove_button.setMnemonic(KeyEvent.VK_R);
+	    remove_button.setEnabled(false);
+
+	    clear_button = new JButton(get("Clear_Default"));
+	    clear_button.setMnemonic(KeyEvent.VK_C);
+	    clear_button.setEnabled(false);
+
+	    set_button = new JButton(get("Set_Default"));
+	    set_button.setMnemonic(KeyEvent.VK_S);
+	    set_button.setEnabled(false);
 
 	    // Set up and connect listeners.
-	    add.addActionListener(new AddListener());
-	    clear_default.addActionListener(new ClearDefaultListener());
-	    remove.addActionListener(new RemoveListener());
-	    selector.addActionListener(new SelectorListener());
-	    set_default.addActionListener(new SetDefaultListener());
-	    list.addListSelectionListener(new ListListener());
+	    add_button.addActionListener(new AddListener());
+	    clear_button.addActionListener(new ClearDefaultListener());
+	    remove_button.addActionListener(new RemoveListener());
+	    selector_combobox.addActionListener(new SelectorListener());
+	    set_button.addActionListener(new SetDefaultListener());
+	    language_list.addListSelectionListener(new ListListener());
 	    // Layout components.
 	    default_panel.setBorder(BorderFactory.createRaisedBevelBorder());
 	    default_panel.setLayout(new BorderLayout());
 	    default_panel.add(default_label, BorderLayout.WEST);
-	    default_panel.add(default_language_value, BorderLayout.CENTER);
+	    default_panel.add(default_language_field, BorderLayout.CENTER);
 
 	    control_panel.setBorder(BorderFactory.createEmptyBorder(5,0,0,0));
 	    control_panel.setLayout(new BorderLayout());
 	    control_panel.add(selector_label, BorderLayout.WEST);
-	    control_panel.add(selector, BorderLayout.CENTER);
+	    control_panel.add(selector_combobox, BorderLayout.CENTER);
 
 	    details_panel.setBorder(BorderFactory.createEmptyBorder(5,0,5,0));
@@ -510,12 +343,12 @@
 	    center_panel.setLayout(new BorderLayout());
 	    center_panel.add(title_label, BorderLayout.NORTH);
-	    center_panel.add(new JScrollPane(list), BorderLayout.CENTER);
+	    center_panel.add(new JScrollPane(language_list), BorderLayout.CENTER);
 	    center_panel.add(details_panel, BorderLayout.SOUTH);
 
 	    button_panel.setLayout(new GridLayout(2,2,5,5));
-	    button_panel.add(add);
-	    button_panel.add(remove);
-	    button_panel.add(clear_default);
-	    button_panel.add(set_default);
+	    button_panel.add(add_button);
+	    button_panel.add(remove_button);
+	    button_panel.add(clear_button);
+	    button_panel.add(set_button);
 
 	    setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
@@ -524,8 +357,14 @@
 	    add(button_panel, BorderLayout.SOUTH);
 	}
-	/** Destructor.
-			*/
+	/** Destructor.	*/
 	public void destroy() {
 	}
+
+	public void gainFocus() {
+	}
+
+	public void loseFocus() {
+	}
+
 	/** Listens for actions apon the 'add' button in the LanguageManager controls, and if detected calls the add method of the manager with a newly created language. */
 	private class AddListener
@@ -536,10 +375,12 @@
 	     */
 	    public void actionPerformed(ActionEvent event) {
-		Language language = (Language)selector.getSelectedItem();
-		if(language != null) {
-		    addLanguage(new Language(language));
-		}
-	    }
-	}
+		String language_code = (String) selector_combobox.getSelectedItem();
+		if(language_code != null) {
+		    addLanguage(new Language(language_code));
+		}
+		add_button.setEnabled(false);
+	    }
+	}
+
 	/** Listens for actions apon the 'clear default' button in the LanguageManager controls, and if detected calls the setDefault method of the manager with <i>null</i>. */
 	private class ClearDefaultListener
@@ -550,8 +391,9 @@
 	    public void actionPerformed(ActionEvent event) {
 		setDefault(null);
-		clear_default.setEnabled(false);
-		default_language_value.setText("");
-	    }
-	}
+		clear_button.setEnabled(false);
+		default_language_field.setText("");
+	    }
+	}
+
 	/** Listens for actions apon the 'remove' button in the LanguageManager controls, and if detected calls the remove method of the manager with the language selected for removal. */
 	private class RemoveListener
@@ -562,14 +404,18 @@
 	     */
 	    public void actionPerformed(ActionEvent event) {
-		if(!list.isSelectionEmpty()) {
-		    removeLanguage((Language)list.getSelectedValue());
-		    if(default_language == null) {
-			clear_default.setEnabled(false);
-			default_language_value.setText("");
+		Language delete_me = (Language)language_list.getSelectedValue();
+		if(delete_me != null) {
+		    removeLanguage(delete_me);
+		    if(default_language != null && default_language.equals(delete_me)) {
+			setDefault(null);
+			clear_button.setEnabled(false);
+			default_language_field.setText("");
 		    }
 		}
-	    }
-	}
-	/** Listens for selections wihtin the combobox on the LanguageManager controls, and if a change is detected enables, or disables, controls appropriately. */
+		remove_button.setEnabled(false);
+	    }
+	}
+
+	/** Listens for selections within the combobox on the LanguageManager controls, and if a change is detected enables, or disables, controls appropriately. */
 	private class SelectorListener
 	    implements ActionListener {
